import SDL;
import opengl;
import std.c.windows.windows;

enum : uint { CCHDEVICENAME = 32 }
enum : uint { CCHFORMNAME = 32 }

struct _POINTL {
  int x;
  int y;
}
alias _POINTL POINTL;
struct _devicemodeA {
  BYTE dmDeviceName[CCHDEVICENAME];
  WORD dmSpecVersion;
  WORD dmDriverVersion;
  WORD dmSize;
  WORD dmDriverExtra;
  DWORD dmFields;
union {
struct {
  short dmOrientation;
  short dmPaperSize;
  short dmPaperLength;
  short dmPaperWidth;
}

  POINTL dmPosition;
}

  short dmScale;
  short dmCopies;
  short dmDefaultSource;
  short dmPrintQuality;
  short dmColor;
  short dmDuplex;
  short dmYResolution;
  short dmTTOption;
  short dmCollate;
  BYTE dmFormName[CCHFORMNAME];
  WORD dmLogPixels;
  DWORD dmBitsPerPel;
  DWORD dmPelsWidth;
  DWORD dmPelsHeight;
union {
  DWORD dmDisplayFlags;
  DWORD dmNup;
}

  DWORD dmDisplayFrequency;
// #if(WINVER >= 0x0400)
  DWORD dmICMMethod;
  DWORD dmICMIntent;
  DWORD dmMediaType;
  DWORD dmDitherType;
  DWORD dmReserved1;
  DWORD dmReserved2;
// #if (WINVER >= 0x0500) || (_WIN32_WINNT >= 0x0400)
  DWORD dmPanningWidth;
  DWORD dmPanningHeight;
// #endif
// #endif /* WINVER >= 0x0400 */
}

alias _devicemodeA DEVMODEA;

extern(Windows) export BOOL EnumDisplaySettingsA(
  char* lpszDeviceName,  // ディスプレイデバイス
  uint iModeNum,      // グラフィックスモード
  DEVMODEA* lpDevMode  // グラフィックスモードの設定
);

enum : uint { DM_SPECVERSION = 0x0401 }
// #elif (WINVER >= 0x0400)
// #...
// #else
// #...
// #endif /* WINVER */

enum : uint { DM_ORIENTATION = 0x00000001 }
enum : uint { DM_PAPERSIZE = 0x00000002 }
enum : uint { DM_PAPERLENGTH = 0x00000004 }
enum : uint { DM_PAPERWIDTH = 0x00000008 }
enum : uint { DM_SCALE = 0x00000010 }
// #if(WINVER >= 0x0500)
enum : uint { DM_POSITION = 0x00000020 }
enum : uint { DM_NUP = 0x00000040 }
// #endif /* WINVER >= 0x0500 */
enum : uint { DM_COPIES = 0x00000100 }
enum : uint { DM_DEFAULTSOURCE = 0x00000200 }
enum : uint { DM_PRINTQUALITY = 0x00000400 }
enum : uint { DM_COLOR = 0x00000800 }
enum : uint { DM_DUPLEX = 0x00001000 }
enum : uint { DM_YRESOLUTION = 0x00002000 }
enum : uint { DM_TTOPTION = 0x00004000 }
enum : uint { DM_COLLATE = 0x00008000 }
enum : uint { DM_FORMNAME = 0x00010000 }
enum : uint { DM_LOGPIXELS = 0x00020000 }
enum : uint { DM_BITSPERPEL = 0x00040000 }
enum : uint { DM_PELSWIDTH = 0x00080000 }
enum : uint { DM_PELSHEIGHT = 0x00100000 }
enum : uint { DM_DISPLAYFLAGS = 0x00200000 }
enum : uint { DM_DISPLAYFREQUENCY = 0x00400000 }
// #if(WINVER >= 0x0400)
enum : uint { DM_ICMMETHOD = 0x00800000 }
enum : uint { DM_ICMINTENT = 0x01000000 }
enum : uint { DM_MEDIATYPE = 0x02000000 }
enum : uint { DM_DITHERTYPE = 0x04000000 }
enum : uint { DM_PANNINGWIDTH = 0x08000000 }
enum : uint { DM_PANNINGHEIGHT = 0x10000000 }
// #endif /* WINVER >= 0x0400 */

extern(Windows) export BOOL SwapBuffers(HDC);
extern(Windows) export int ChangeDisplaySettingsA(
    DEVMODEA*  lpDevMode,
    uint       dwFlags);

void main(char[][] argv) {
	DEVMODEA dm;
	dm.dmSize = DEVMODEA.sizeof;

	dm.dmFields = DM_BITSPERPEL | DM_PELSWIDTH | DM_PELSHEIGHT | DM_DISPLAYFREQUENCY;
	dm.dmPelsWidth = 640;			// 画面の幅
	dm.dmPelsHeight = 480;			// 画面の高さ
	dm.dmBitsPerPel = 16;			// ビット数
//dm.dmDisplayFrequency = 60;	// リフレッシュレートは設定しない
	DEVMODEA dm2 = dm;

	enum :uint { ENUM_CURRENT_SETTINGS     =  -1 }
	enum :uint { ENUM_REGISTRY_SETTINGS    =  -2 }

// 現在の画面情報を取得 >


	SDL_Init(SDL_INIT_VIDEO);
	int width = 640;
	int height = 480;
	SDL_SetVideoMode(width, height, 0,  SDL_OPENGL | SDL_FULLSCREEN);
//	SDL_Delay(1000);

//	SDL_SysWMinfo s;
//	SDL_GetWMInfo(&s);
//	SDL_Delay(1000);
	SDL_GL_SwapBuffers();
//	SDL_Delay(1000);
/*	SDL_GL_SwapBuffers();
	SDL_Delay(1000);
	SDL_GL_SwapBuffers();
	SDL_Delay(1000);*/
//	printf("%d\n", s.window);
//	HDC hdc = GetDC(cast(HANDLE)s.window);
//	printf("%d\n", hdc);
//	SwapBuffers(hdc);
//	SwapBuffers(hdc);
//	ReleaseDC(cast(HANDLE)s.window, hdc);
//	SwapBuffers(null);
//	SwapBuffers(null);

	enum { DISP_CHANGE_SUCCESSFUL      = 0 }
/*
	if(ChangeDisplaySettingsA(&dm, 0) != DISP_CHANGE_SUCCESSFUL){
		printf("koko\n");
		return FALSE;
	}*/
	
	enum : uint { CDS_FULLSCREEN =     0x00000004 }
	enum : uint { CDS_RESET =          0x40000000 };
	EnumDisplaySettingsA(null, ENUM_CURRENT_SETTINGS, &dm2);
	ChangeDisplaySettingsA(&dm2, CDS_RESET);

	SDL_Quit();
}

