import SDL;
import opengl;
import std.c.windows.windows;


void main(char[][] argv) {

	SDL_Init(SDL_INIT_VIDEO);
	int width = 640;
	int height = 480;
	SDL_SetVideoMode(width, height, 0,  SDL_OPENGL | SDL_FULLSCREEN);
	SDL_GL_SwapBuffers();
	SDL_Delay(1000);
}

enum : uint { CCHDEVICENAME = 32 }
enum : uint { CCHFORMNAME = 32 }
struct POINTL {
  int x;
  int y;
}
struct DEVMODEA {
  BYTE dmDeviceName[CCHDEVICENAME];
  WORD dmSpecVersion;
  WORD dmDriverVersion;
  WORD dmSize;
  WORD dmDriverExtra;
  DWORD dmFields;
  union {
    struct {
      short dmOrientation;
      short dmPaperSize;
      short dmPaperLength;
      short dmPaperWidth;
    }
    POINTL dmPosition;
  }
  short dmScale;
  short dmCopies;
  short dmDefaultSource;
  short dmPrintQuality;
  short dmColor;
  short dmDuplex;
  short dmYResolution;
  short dmTTOption;
  short dmCollate;
  BYTE dmFormName[CCHFORMNAME];
  WORD dmLogPixels;
  DWORD dmBitsPerPel;
  DWORD dmPelsWidth;
  DWORD dmPelsHeight;
  union {
    DWORD dmDisplayFlags;
    DWORD dmNup;
  }
  DWORD dmDisplayFrequency;
  DWORD dmICMMethod;
  DWORD dmICMIntent;
  DWORD dmMediaType;
  DWORD dmDitherType;
  DWORD dmReserved1;
  DWORD dmReserved2;
  DWORD dmPanningWidth;
  DWORD dmPanningHeight;
}

extern(Windows) export BOOL EnumDisplaySettingsA(
  char* lpszDeviceName,
  uint iModeNum,
  DEVMODEA* lpDevMode
);

extern(Windows) export int ChangeDisplaySettingsA(
	DEVMODEA*  lpDevMode,
    uint       dwFlags);

static ~this() {

	DEVMODEA dm;
	dm.dmSize = DEVMODEA.sizeof;
	enum :uint { ENUM_CURRENT_SETTINGS     =  -1 }
	enum :uint { ENUM_REGISTRY_SETTINGS    =  -2 }
	EnumDisplaySettingsA(null, ENUM_CURRENT_SETTINGS, &dm);
	enum : uint { CDS_FULLSCREEN =     0x00000004 }
	enum : uint { CDS_RESET =          0x40000000 }
	ChangeDisplaySettingsA(&dm, CDS_RESET);

	SDL_Quit();
}
