private import all;

class AB: TaskObject {
	mixin GROUP!(GROUP_PARTICLE);

	float x;
	float y;
	char name;

	this(float _x, float _y, char _name) {
		x = _x;
		y = _y;
		name = _name;
		init();
		move = &move1;
		draw = &draw1;
	}

	~this() {
	}

	Pos pos(int no) {
		return _pos[no];
	}

	Link link(int no) {
		return _link[no];
	}

	void init() {
		_pos.length = 4;
		_link.length = 6;
		for (int i = 0; i < _pos.length; i++) {
			_pos[i] = new Pos();
		}
		for (int i = 0; i < _link.length; i++) {
			_link[i] = new Link();
		}
		_pos[0].setPos(-1, -1 - 10);
		_pos[1].setPos( 1, -1 - 10);
		_pos[2].setPos(-1,  1 - 10);
		_pos[3].setPos( 1,  1 - 10);

		for (int i = 0; i < _pos.length; i++) {
			_pos[i].stop();
		}
			_pos[0].accelPos(new Vector2(0.05, 0.002));
			_pos[1].accelPos(new Vector2(0.05, 0.002));
			_pos[2].accelPos(new Vector2(-0.05, 0.002));
			_pos[3].accelPos(new Vector2(-0.05, 0.002));

		_link[0].init(_pos[0], _pos[1]);
		_link[1].init(_pos[2], _pos[3]);
		_link[2].init(_pos[0], _pos[2]);
		_link[3].init(_pos[1], _pos[3]);
		_link[4].init(_pos[0], _pos[3]);
		_link[5].init(_pos[1], _pos[2]);
	}

	void calcVel() {
		Vector2 vX = (((_pos[0].pos() - _pos[1].pos()) + (_pos[2].pos() - _pos[3].pos())) / 2.0).norm();
		Vector2 vY = (((_pos[0].pos() - _pos[2].pos()) + (_pos[1].pos() - _pos[3].pos())) / 2.0).norm();

		for (int i = 0; i < _pos.length; i++)
		  _pos[i].setVel(vX, vY);
	}
	void move1() {
		if (pads & PAD_BUTTON2) {
			turn(0.01);
		}
		for (int j = 0; j < 4; j++) {
			preMove();
			postMove();
		}
	}
	void preMove() {
		for (int i = 0; i < _pos.length; i++) {
			_pos[i].preMove();
		}
	}

	void postMove() {
		for (int j = 0; j < 4; j++)
			for (int i = 0; i < _link.length; i++)
				_link[i].check();

		calcVel();

		for (int i = 0; i < _pos.length; i++)
		  _pos[i].postMove();

		for (int i = 0; i < _pos.length; i++)
		  _pos[i].check();
	}

	void turn(double r) {
		Vector2 v = new Vector2(r, 0);

		_pos[1].accelLocalPos(v);
		_pos[3].accelLocalPos(-1 * v);
//		_pos[2].accelLocalPos(v*(rand()%256) / 256.0);
//		_pos[3].accelLocalPos(v*(rand()%256) / 256.0);
	}

	void draw1() {
		glPushMatrix();
		float z = 5000;
		glScalef(z,z,1);
		glTranslatef(x-10,y,0);
		glColor4f(1, 0, 0, 1);

		glBegin(GL_LINE_LOOP);

//		glVertex3f  (_pos[0].pos().x, _pos[0].pos().y, 0);
//		glVertex3f  (_pos[1].pos().x, _pos[1].pos().y, 0);
//		glVertex3f  (_pos[3].pos().x, _pos[3].pos().y, 0);
//		glVertex3f  (_pos[2].pos().x, _pos[2].pos().y, 0);
		/*
		0,0のとき0
		1,0のとき1
		0,1のとき2
		1,1のとき3となる補完をすればよろしい。
		x,yが入力されたら
		*/
		static char[] c = "D.pdr";
		c[0] = name;
		float[][] pp = pdrs[c];
		glEnd();
		for (int i = 0; i < pp.length; i++) {
			drawPdr(pp[i]);
		}
		glPopMatrix();
	}
	void newPos(double x, double y, out double newX, out double newY) {
		x = (x + 1200) / 2400 ;
		y = (y + 1200) / 2400 ;
		double newX1 = _pos[0].pos().x * x + _pos[1].pos().x * (1 - x);
		double newY1 = _pos[0].pos().y * x + _pos[1].pos().y * (1 - x);
		double newX2 = _pos[2].pos().x * x + _pos[3].pos().x * (1 - x);
		double newY2 = _pos[2].pos().y * x + _pos[3].pos().y * (1 - x);
		newX = newX1 * y + newX2 * (1 - y);
		newY = newY1 * y + newY2 * (1 - y);
	}

	void drawPdr(float[] d) {
		double newX, newY;
		if (d[3] != 0.0f) {
			glColor4f(d[0], d[1], d[2], d[3]);
			glBegin(GL_TRIANGLE_FAN);
			for (int i = 0; i < (d.length - 8)/3; i++) {
				newPos(d[8+i*3], d[8+i*3+1], newX, newY);
				//printf("%f %f\n" ,newX, newY);
				glVertex3f  (newX, newY, d[8+i*3+2]);
			}
			glEnd();
		}
		glColor4f(d[4], d[5], d[6], d[7]);

		glBegin(GL_LINE_LOOP);
		for (int i = 0; i < (d.length - 8)/3; i++) {
				newPos(d[8+i*3], d[8+i*3+1], newX, newY);
				glVertex3f  (newX, newY, d[8+i*3+2]);
		}
		glEnd();
	}

	Pos _pos[];
	Link _link[];
}

private import std.math;

class Vector2 {
	double x, y;

	this() {
	}

	this(double ax, double ay = 0.0) {
		x = ax;
		y = ay;
	}

	void set(double ax = 0.0, double ay = 0.0) {
		x = ax;
		y = ay;
	}

	// +
	Vector2 opAdd(Vector2 av) {
		return new Vector2(x + av.x, y + av.y);
	}

	// +=
	Vector2 opAddAssign(Vector2 av) {
		x += av.x;
		y += av.y;
		return this;
	}

	// -
	Vector2 opSub(Vector2 av) {
		return new Vector2(x - av.x, y - av.y);
	}

	// -=
	Vector2 opSubAssign(Vector2 av) {
		x -= av.x;
		y -= av.y;
		return this;
	}

	// *
	Vector2 opMul(double a) {
		return new Vector2(x * a, y * a);
	}

	// *=
	Vector2 opMulAssign(double a) {
		x *= a;
		y *= a;
		return this;
	}

	// /
	Vector2 opDiv(double a) {
		return new Vector2(x / a, y / a);
	}

	// /=
	Vector2 opDivAssign(double a) {
		x /= a;
		y /= a;
		return this;
	}

	Vector2 move(Vector2 av, double at) {
		x += av.x * at; 
		y += av.y * at; 
		return this;
	}

	double abs() {
		return sqrt(abs2());
	}

	double abs2() {
		return x * x + y * y;
	}

	// 内積
	double inprod(Vector2 av) {
		return x * av.x + y * av.y;
	}

	// 外積
	double outprod(Vector2 av) {
		double az;
		az = (x * av.y - y * av.x);
		return az;
	}

	// 単位ベクトルを求める
	Vector2 norm() {
		double v = abs();
		return new Vector2(x / v, y / v);
	};

	// 単位ベクトル化
	Vector2 normalize() {
		double v = abs();
		x /= v;
		y /= v;
		return this;
	}
}

class Link : TaskObject {
	mixin GROUP!(GROUP_PARTICLE);

	this() {
	}


	Pos pos1() {
		return _pos1;
	}

	Pos pos2() { 
		return _pos2;
	}

	double constDistance() {
		return _distance;
	}

	double distance() {
		return (_pos1.pos() - _pos2.pos()).abs();
	}

	void init(Pos p1, Pos p2) {
		_pos1 = p1;
		_pos2 = p2;
		initDistance();
	}

	void initDistance() {
		_distance = distance();
	}

	void check() {
		Vector2 vDis = _pos1.pos() - _pos2.pos();
		double r = vDis.abs();
		_pos1.accelPos(vDis * (_distance - r) * 0.0005);
		_pos2.accelPos(vDis * (r - _distance) * 0.0005);
	}

protected:
	Pos _pos1;
	Pos _pos2;
	double _distance;
}

import std.math;

const double DT = 0.1;

class Pos : TaskObject{
	mixin GROUP!(GROUP_PARTICLE);

	this() {
		_p = new Vector2();
		_op = new Vector2();
		_v = new Vector2();
		_vX = new Vector2();
		_vY = new Vector2();
	}

	Vector2 pos() {
		return _p;
	}

	Vector2 oldPos() {
		return _op;
	}

	Vector2 vX() {
		return _vX;
	}

	Vector2 vY() {
		return _vY;
	}

	void setPos(Vector2 ap) {
		_p = ap;
	}

	void setPos(double ax, double ay) {
		_p.set(ax, ay);
	}

	void setVel(Vector2 ax, Vector2 ay) {
		_vX = ax;
		_vY = ay;
	}

	void accelPos(Vector2 ndp) {
		_p = _p + ndp;
	}

	void accelLocalPos(Vector2 ndp) {
		_p = _p + _vX * ndp.x + _vY * ndp.y;
	}

	void brakePos(double r) {
		_p = _p - stepVel() * r;
	}

	Vector2 stepVel() {
		return _p - _op;
	}

	Vector2 vel() {
		return (_p - _op) / DT;
	}

	void stop() {
		_op = _p; 
		_v.set(0, 0);
	}

	void preMove() {
		_p = _p + _v;
	}

	void postMove() {
		_v = (_p - _op);// * 0.999;
		_op = _p;
	}

	void check() {
		_p.y += 0.1;
		if (_p.y > 0) {
			_p.y = 0;
		}
	}

protected:
	Vector2 _p;
	Vector2 _op;
	Vector2 _v;
	Vector2 _vX;
	Vector2 _vY;
}
