private import all;
private import std.c.stdio;

class Game: TaskObject {
	mixin GROUP!(GROUP_GAME);
	float zoom;
	static Game gameData;
	int stage;
	int count;
	int score;
	int step;
	bool pause;
	this() {
		pause = true;
		move = &demoStart;
		gameData = this;
	}

	static Game game() {
		return gameData;
	}
	static void addScore(int i) {
		if (gameData.move == &gameData.gameExec2) {
			gameData.score+=i;
		}
	}
	void demoStart() {
		move = &demo;
		draw = null;
		step = -3;
		count = 0;
	}

	void demo() {
		count++;
		
		if (count == 10) {
			try {
				switch (step) {
				case 0: new AB(0,-1,'D');		 break;
				case 1: new AB(3,-1,'K'); break;
				case 2: new AB(6,-1,'O'); playSNDmusic("demo.ogg", 1);break;
				case 3: new AB(9,-1,'K'); break;
				case 4: new AB(12,-1,'A'); break;
				case 5: new AB(8,2,'G'); break;
				case 6: new AB(11,2,'A'); break;
				case 7: new AB(14,2,'M'); break;
				case 8: new AB(17,2,'E'); break;
				case 9: new AB(20,2,'S'); break;
				case 30: move = &titleStart; break;
				default: break;
				}
			} catch (OutOfMemoryException e) {}
			step++;
			count = 0;
		}
		if (pads & PAD_BUTTON1) move = &titleStart;
		if (trgs & PAD_BUTTON9) tl.exit = true;
	}

	void titleStart() {
		pause = true;
		stopSNDmusic();
		count = 0;
		printf("titleStart\n");
		tl.map(GROUP_GFX, delegate int(inout TaskObject o) { o.deleteThis(); return 0;});
		tl.map(GROUP_CURSOR, delegate int(inout TaskObject o) { o.deleteThis(); return 0;});
		tl.map(GROUP_TANK, delegate int(inout TaskObject o) {o.deleteThis(); return 0;});
		tl.map(GROUP_PARTICLE, delegate int(inout TaskObject o) {o.deleteThis(); return 0;});
		tl.map(GROUP_GENERATOR, delegate int(inout TaskObject o) {o.deleteThis(); return 0;});
		tl.map(GROUP_TEXT, delegate int(inout TaskObject o) {o.deleteThis(); return 0;});

		move = &title;
		draw = &titleDraw;
		zoom = 50;
		printf("titleStart ok\n");
	}

	void title() {
		if (zoom > 10)
			zoom -= 1;
		else
			move = &title2;
		title3();
	}
	void title2() {
		playSNDmusic("title.ogg");
		playSNDse("generators");
		move = &title3;
		title3();
		step = 0;
	}
	void title3() {
		if (trgs & PAD_BUTTON1) {
			move = &gameStart;
			return;
		}
		if (trgs & PAD_BUTTON9) {
			tl.exit = true;
			foreach (TaskObject o; tl) {
				o.deleteThis();
			}
		}
		count++;
		step++;
		if (step > 3800) move = &demoStart;
	}
	
	void gameStart() {
		score = 0;
		tl.map(GROUP_SHIP, delegate int(inout TaskObject o) {o.deleteThis(); return 0;});
		try {
			new Course();
			new Ship();
			new Camera();

		} catch (OutOfMemoryException e) {}
		stage = 1;
		//pause = true;
		move = &gameStart1;
		draw = &gameStartDraw;
		step = 0;
	}

	void gameStart1() {
		count = 0;
		move = &gameStart2;
//		stopSNDmusic();
//		playSNDmusic("galaga.ogg",1);
	}

	void gameStart2() {
		if (trgs & PAD_BUTTON9) {
			titleStart();
		}
		
		pause = false;
		count++;
		if (count == 60*3) {
			if (stage % 3 == 1) {
				switch(rand() % 3) {
				case 0: playSNDmusic("stage1.ogg"); break;
				case 1: playSNDmusic("stage2.ogg"); break;
				case 2: playSNDmusic("stage3.ogg"); break;
				}
			}
			draw = &gameStartDraw;
		}
		if (count > 60*6) {
			pause = false;
			draw = &gameDraw;
			move = &gameExec;
		}
	}


	static void delegate()[] data;
	static void delegate()[] dellist(void delegate()[] ds...) { return ds.dup; }
	static this() {
		data = dellist();
	}

	void gameExec() {
		move = &gameExec2;
	}

	void gameExec2() {
		if (trgs & PAD_BUTTON9) {
			titleStart();
		}
	}

	void gameOverStart() {
		move = &gameOver;
		draw = &gameOverDraw;
		count = 0;
		playSNDse("gameover");
	}

	void gameOver() {
		count++;
		if (trgs & PAD_BUTTON9 | trgs & PAD_BUTTON1) {
			titleStart();
		}
		if (count > 1000) {
			titleStart();
		}
	}

	void gameStartDraw() {
		glPushMatrix();
		glTranslatef(-100*100.0 + 0*100, -140*100.0, 0.0);
		glScalef( 0.075 * 10, 0.15 * 10, 0.2  * 10);
		char[10] s;
		char[] ss = s[0..9];
		sprintf(cast(char*)s, cast(char*)"STAGE %3d", stage);
		util_ascii.draw(ss);
		glPopMatrix();
		gameDraw();
	}

	void gameClearDraw() {
		glPushMatrix();
		glTranslatef(-100*100.0 + 0*100, -140*100.0, 0.0);
		glScalef( 0.075 * 10, 0.15 * 10, 0.2  * 10);
		util_ascii.draw("CLEAR");
		glPopMatrix();
		gameDraw();
	}

	void gameDraw() {
		glPushMatrix();
		glTranslatef(-400*100.0 + 0*100, -440*100.0, 0.0);
		glScalef( 0.075 * 10, 0.15 * 10, 0.2  * 10);
		char[6+8+1] s;
		char[] ss = s[0..6+8];
		sprintf(cast(char*)s, cast(char*)"SCORE %08d", score);
		util_ascii.draw(ss);
		glPopMatrix();
	}

	void gameOverDraw() {
		gameDraw();
		glPushMatrix();
		glScalef( 0.25*10, 0.3*10, 0.2*10 );
		util_ascii.draw("GAME OVER");
		glPopMatrix();
	}

	void titleDraw() {
		glPushMatrix();
		glScalef( zoom, zoom, zoom );
		pdr.draw("Title.pdr");
		glScalef( 0.1 , 0.3, 0.2 );
		glTranslatef(0, 30*100.0, 0.0);
		if (zoom <= 10.0 && count < 30)
			util_ascii.draw("PRESS SHOT BUTTON");
		if (count > 60) count = 0;
		glPopMatrix();
	}
}
