private import all;

static int width = 640;
static int height = 480;
static float nearPlane = 500;
static float farPlane = 100000;
extern(C) void SDL_SetModuleHandle(void *hInst);
private import std.c.windows.windows;
//extern(Windows) export void* GetModuleHandle(char*);

static this()
{
	/* Load SDL dynamic link library */
	if (SDL_Init(SDL_INIT_NOPARACHUTE) < 0)
		throw new Error("Error loading SDL");
	SDL_SetModuleHandle(GetModuleHandleA(null));
}

int main() {
	printf("start main\n");
	initSDL();
	tl = new TaskList(2000);

	new Game();
	printf("init Game\n");

	if (!initPAD()) {
		printf("PAD initialize failed.\n");
		closeSDL();
		return	0;
	}

	if (!initSND()) {
		printf("SOUND initialize failed.\n");
		closePAD();
		closeSDL();
		return	0;
	}
	printf("load char\n");
	loadDir("char");
	printf("load snd\n");
	loadDirSND("snd");
	printf("load snd\n");
	pdr.loadDir("char");
	util_ascii.loadAsciiDir("char/ascii");
	printf("start loop\n");
	loop();
	closeSDL();
	return 0;
}

void initSDL() {
	SDL_Surface* scr;

	if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_NOPARACHUTE) < 0) {
		throw new Exception(
		"Unable to initialize SDL: " ~ std.string.toString(SDL_GetError()));
	}

//	if ((scr = SDL_SetVideoMode(width, height, 0, SDL_OPENGL | SDL_GL_DOUBLEBUFFER | SDL_FULLSCREEN)) == null) {
//	if ((scr = SDL_SetVideoMode(width, height, 0, SDL_OPENGL)) == null) {
	if ((scr = SDL_SetVideoMode(width, height, 0, SDL_OPENGL | SDL_GL_DOUBLEBUFFER)) == null) {
		throw new Exception
		("Unable to create SDL screen: " ~ std.string.toString(SDL_GetError()));
	}
	SDL_ShowCursor(0);
	SDL_WM_SetCaption("generators\0", null);
	glClearColor(1f, 1f, 1f, 1f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
glFinish();
	glFlush();
	SDL_GL_SwapBuffers();
	glLineWidth(1);
	glEnable(GL_LINE_SMOOTH);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
}

void loop() {
	int ticks_ = SDL_GetTicks() + 1000/60;
	int now;
	w:
	while(true) {
		getPAD();
		if(!move()) break;
		now = SDL_GetTicks();
		if (ticks_ - now < 0) {
			//printf("skip\n");
			ticks_ = now + 1000/60;
			getPAD();
			if(!move()) break;
			now = SDL_GetTicks();
		}
		if(ticks_-now>0){
			SDL_Delay(ticks_ - now);
//			printf("sleep %dms\n", ticks_-now);
		}
		ticks_+=1000/60;
		draw();
		GLenum error = glGetError();
		if (error != GL_NO_ERROR) {
			throw new Exception("OpenGL error");
		}
		glFlush();
		SDL_GL_SwapBuffers();
	}
}


bool move() {
	SDL_Event event;
	while ( SDL_PollEvent(&event) ) {
		switch (event.type) {
		case SDL_QUIT:
			return false;
		default:
			break;
		}
	}
	tl.move();
	return !tl.exit;
}

void draw() {
	glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
	glClear(GL_COLOR_BUFFER_BIT);
	glViewport(0, 0, width, height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum(
		-width / 2, width / 2,		// left,right
		height / 2,-height / 2,		// top,bottom
		nearPlane, farPlane);	// znear, zfar

	gluLookAt(
		0.0,  0.0,   10000.0, // ここから
		0.0,  0.0,   0.0, // ここをみる マイナス方向向いてるのでマイナスが遠くになる。
		0.0,  1.0,   0.0);// 上の方向

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
	glEnable(GL_BLEND);
	glEnable(GL_FOG);
	glFogi(GL_FOG_MODE , GL_LINEAR);
	glFogf(GL_FOG_START , nearPlane);
	glFogf(GL_FOG_END , farPlane);
	static float fogc[]=[1.0,1.0,1.0,1.0];
	glFogfv(GL_FOG_COLOR,&fogc[0]);

	glScalef( 0.1,0.1,0.1 ); 
	int j = 0;
	int k = 0;
	tl.draw();
}

version(Windows) {
import std.c.windows.windows;
struct DEVMODEA {
  BYTE dmDeviceName[36];
  WORD dmSize;
  BYTE dummy[118];
}
enum :uint {
	ENUM_CURRENT_SETTINGS     =  -1,
	CDS_RESET =          0x40000000,
}
extern(Windows) export BOOL EnumDisplaySettingsA(
	char* lpszDeviceName, uint iModeNum, DEVMODEA* lpDevMode);
extern(Windows) export int ChangeDisplaySettingsA(
	DEVMODEA* lpDevMode, uint dwFlags);
void closeSDL() {
	for (int i = 0; i < 2; i++) {
		glClearColor(0f, 0f, 0f, 0f);
		glClear(GL_COLOR_BUFFER_BIT| GL_DEPTH_BUFFER_BIT);
		SDL_GL_SwapBuffers();
	}
	DEVMODEA dm;
	dm.dmSize = DEVMODEA.sizeof;
	EnumDisplaySettingsA(null, ENUM_CURRENT_SETTINGS, &dm);
	ChangeDisplaySettingsA(&dm, CDS_RESET);
	SDL_Quit();
}

} else {
void closeSDL() {
	SDL_Quit();
}
}
