/*
	D-System 'SOUND UTILITY'

		'util_snd.d'

	2003/12/02 jumpei isshiki
*/

private	import	SDL;
private	import	SDL_mixer;
private import std.string;

enum{
//	SND_RATE = 22050,
	SND_RATE = 44100,
	SND_CHANNEL = 2,
	SND_BUFFER = 2048,
}

int	vol_se = 100;
int	vol_music = 75;

private	bool			sound_use = false;

int initSND() {

	if (SDL_InitSubSystem(SDL_INIT_AUDIO) < 0) {
		return	0;
    }

    int		audio_rate;
    Uint16	audio_format;
    int		audio_channels;
    int		audio_buffers;

	audio_rate = SND_RATE;
	audio_format = AUDIO_S16;
	audio_channels = SND_CHANNEL;
	audio_buffers = SND_BUFFER;
	if (Mix_OpenAudio(audio_rate, audio_format, audio_channels, audio_buffers) < 0) {
		sound_use = false;
	} else {
		sound_use = true;
	}
	Mix_QuerySpec(&audio_rate, &audio_format, &audio_channels);
	return	1;
}


void closeSND() {
	if (!sound_use) return;
	freeSND();
	Mix_CloseAudio();
}

void loadSNDmusic(char[] name) {
//	printf("loadSNDmusic %.*s\n", name);
	if (!sound_use) {
		return;
	}
	char[] fileName = sndDir ~ "/" ~ name ~ "\0";
	music[name] = Mix_LoadMUS(cast(char*)fileName);
	if (!music[name]) {
		printf("error %.*s\n", name);
		sound_use = false;
	}
}

void loadSNDse(char[] name) {
	if (!sound_use) return;

	char[] fileName = sndDir ~ "/" ~ name ~ "\0";
	char[][] names = name.split(".");
	chunkChannel[names[0]] = atoi(names[1]);
	chunk[names[0]] = Mix_LoadWAV(cast(char*)fileName);
	if (!chunk[names[0]]) {
		printf("error %.*s\n", name);
		sound_use = false;
	}
}

void freeSND() {
	foreach (Mix_Music* m; music) {
	    if (m) {
			stopSNDmusic();
			Mix_FreeMusic(m);
		}
	}
	music = null;
	foreach (char[] name, Mix_Chunk* chunk; chunk) {
		stopSNDse(name);
		Mix_FreeChunk(chunk);
	}
	chunk = null;
}

void playSNDmusic(char[] name, int num = -1) {
//	printf("%.*s\n", name);
	if (!music[name]) return;
	if (!sound_use) return;
    Mix_PlayMusic(music[name], num);
}


void stopSNDmusic() {
	if (!sound_use) return;

    if (Mix_PlayingMusic()) {
		Mix_HaltMusic();
	}
}


void playSNDse(char[] name) {
	if (!chunk[name]) return;

	if (!sound_use) return;

    Mix_PlayChannel(chunkChannel[name], chunk[name], 0);
}


void stopSNDse(char[] name) {
	if (!chunkChannel[name]) return;
	if (!sound_use) return;
    Mix_HaltChannel(chunkChannel[name]);
}
void stopSNDse(int channel) {
	if (!sound_use) return;
    Mix_HaltChannel(channel);
}


int checkSNDse(int ch) {
	if (ch < 0) return	0;
	if (!sound_use) return	0;
	return Mix_Playing(ch);
}


void stopSNDall() {
	foreach (Mix_Music* m; music) {
	    if (m) stopSNDmusic();
	}
	foreach (int i; chunkChannel) {
		stopSNDse(i);
	}
}

void volumeSNDse(int vol) {
	int master = vol * 128 / 100;
	foreach (Mix_Chunk* i; chunk) {
			Mix_VolumeChunk(i, master);
	}
}

void volumeSNDmusic(int vol) {
	int master = vol * 128 / 100;
	Mix_VolumeMusic(master);
}

private import std.file;
private import std.path;
Mix_Music*[char[]] music;
Mix_Chunk*[char[]] chunk;
int[char[]] chunkChannel;
char[] sndDir;

void loadDirSND(char[] dir) {
	sndDir = dir;
	chunk = null;
	music = null;
	chunkChannel = null;
	foreach (char[] name; listdir(dir)) {
		try {
//			printf("load %.*s\n", name);
			switch (getExt(name)) {
//			case "it": loadSNDmusic(name); break;
			case "mp3": loadSNDmusic(name); break;
			case "ogg": loadSNDmusic(name); break;
			case "wav": loadSNDse(name); break;
			default: break;
			}
		} catch (Exception e) {
			printf("load error %.*s\n", e.toString());
		}
	}
}
